<main data-component="continuum">
  <form [formGroup]="continuumForm">
    <div class="grid-container">
      <div class="grid-item">
        <mat-form-field
          floatLabel="always">
          <mat-label>Integration Time</mat-label>
          <input
            matInput
            placeholder="Enter value..."
            formControlName="integrationTime"
            title="On-source integration time"
            (ngModelChange)="paramChange()">
          <span matSuffix class="mat-form-field-suffix">hours</span>
            <mat-error>
                {{ getErrorMessage(integrationTime) }}
            </mat-error>
        </mat-form-field>

        <mat-form-field
          floatLabel="always">
          <mat-label>Central Frequency</mat-label>
          <input
            matInput
            placeholder="Enter value..."
            formControlName="centralFrequency"
            required
            min="{{centralFrequencyLimits.min}}"
            max="{{centralFrequencyLimits.max}}"
            title="The central frequency of the observation"
            (ngModelChange)="freqParamChange()">
          <span matSuffix class="mat-form-field-suffix">MHz</span>
          <mat-error *ngIf="centralFrequency?.invalid">
            {{ getErrorMessage(centralFrequency) }}
          </mat-error>
        </mat-form-field>

        <mat-form-field
          floatLabel="always">
          <mat-label>Continuum Bandwidth</mat-label>
          <input
            matInput
            placeholder="Enter value..."
            formControlName="continuumBandwidth"
            required
            title="The total bandwidth of the continuum observation"
            (ngModelChange)="paramChange()">
          <span matSuffix class="mat-form-field-suffix">MHz</span>
          <mat-error>
            {{getErrorMessage(continuumBandwidth)}}
          </mat-error>
        </mat-form-field>

        <mat-form-field floatLabel="always">
            <mat-label>Number of sub-bands</mat-label>
            <input
              matInput
              type="number"
              min="{{nSubbandsLimits.min}}" max="{{nSubbandsLimits.max}}"
              formControlName="nSubbands"
            required>
            <mat-error id="errNSubbands">
              {{getErrorMessage(nSubbands)}}
            </mat-error>
        </mat-form-field>

        <mat-form-field class="resolution-display"
          floatLabel="always">
          <mat-label>Spectral Resolution</mat-label>
          <input
            matInput
            formControlName="spectralResolution"
            title="Channel spacing of continuum data"
            readonly
            style="width: 60px;">
          <span>{{getSpectralResolutionVelocityDisplayValue()}}</span>
        </mat-form-field>

        <article style="width: 97%;">
          <mat-form-field
            floatLabel="always"
            title="Factor by which the intrinsic resolution should be averaged">
            <mat-label>Spectral Averaging</mat-label>
            <input
              matInput
              placeholder="Enter value..."
              type="number"
              formControlName="spectralAveraging"
              required
              min="{{spectralAveragingLimits.min}}"
              max="{{spectralAveragingLimits.max}}"
              (ngModelChange)="spectralAveragingChanged()">
            <mat-error>
                {{getErrorMessage(spectralAveraging)}}
            </mat-error>
          </mat-form-field>

          <mat-form-field
            floatLabel="always"
            title="Select an image weighting option">
            <mat-label>Effective resolution</mat-label>
            <input
              matInput
              title="Spectral resolution after averaging"
              formControlName="effectiveResolution"
              readonly>
          </mat-form-field>
        </article>

        <article style="width: 97%;">
          <mat-form-field title="Select an image weighting option">
            <mat-label>Image Weighting</mat-label>
            <mat-select formControlName="imageWeighting" (selectionChange)="weightingChanged()">
              <ng-container *ngFor="let item of imageWeightingOptions">
                <mat-option [value]="item">{{item}}</mat-option>
              </ng-container>
            </mat-select>
          </mat-form-field>

          <mat-form-field *ngIf="showRobustness"
                          style="margin-right: 10px;"
                          title="Select a robustness">
            <mat-label>Robust Value</mat-label>
            <mat-select formControlName="robust" (selectionChange)="paramChange()">
              <ng-container *ngFor="let robustness of robustOptions">
                <mat-option [value]="robustness">{{robustness}}</mat-option>
              </ng-container>
            </mat-select>
          </mat-form-field>
        </article>
      </div>
      <div class="grid-item">
        <app-continuum-results [nSubbands]="nSubbands?.value" [lowContinuumResults]="lowContinuumResults"></app-continuum-results>
      </div>
    </div>
  </form>
</main>
